#region Copyright Syncfusion Inc. 2001 -2004
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////// 
//  Copyright Syncfusion Inc. All rights reserved. Use of this code is subject to the terms of our 
//  license. A copy of the current license can be obtained at any time by e-mailing licensing@syncfusion.com. 
//  Re-distribution in any form is strictly prohibited. Any infringement will be prosecuted under applicable laws. 
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////// 
#endregion 
 
using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.IO;


using Syncfusion.Windows.Forms.Diagram;



using System.Reflection;

using System.CodeDom.Compiler;

using Microsoft.CSharp;      // and/or Microsoft.VisualBasic;



namespace Syncfusion.Windows.Forms.Diagram.Samples.OrgChart
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class frmDecisionTree : System.Windows.Forms.Form
	{
		private System.ComponentModel.IContainer components;
		private System.Windows.Forms.Panel panel1;
		private Syncfusion.Windows.Forms.Diagram.Controls.Diagram diagram;
		private Syncfusion.Windows.Forms.Tools.XPMenus.MainFrameBarManager mainFrameBarManager;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemLink;
		private Syncfusion.Windows.Forms.Tools.XPMenus.Bar bar2;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemUpdateLayout;
		private System.Windows.Forms.ImageList imageList1;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemFileExit;
		private Syncfusion.Windows.Forms.Tools.XPMenus.ParentBarItem parentBarItemFile;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemSelectTool;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemAutoLayout;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemEditCut;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemEditCopy;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemEditPaste;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemNodeInfo;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemShowTitle;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemAutoAdd;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemAddCondition;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemAddAlternative;
		private System.Windows.Forms.ImageList smBarItemImages;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemZoomTool;
		private Syncfusion.Windows.Forms.Tools.XPMenus.PopupMenu popSymbol;
		private Syncfusion.Windows.Forms.Tools.XPMenus.ParentBarItem parentBarItem3;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemEditCondition;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemDispDesc;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemDispCond;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemEditAlternative;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemDispAlterCode;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemDispAlterDesc;
		private System.Windows.Forms.OpenFileDialog openDiagramDialog;
		private System.Windows.Forms.SaveFileDialog saveDiagramDialog;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemSave;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemSaveAs;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemOpen;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemEditLink;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemDelete;
		private Syncfusion.Windows.Forms.Tools.XPMenus.ParentBarItem popSymbolParent;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemDisplayYesNo;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemHideYesNo;
		private Syncfusion.Windows.Forms.Tools.XPMenus.Bar barFile;
		private Syncfusion.Windows.Forms.Tools.XPMenus.Bar barEdit;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemNew;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemPan;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemRedo;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemPrint;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemPreview;
		private Syncfusion.Windows.Forms.Tools.XPMenus.Bar barTest;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemUndo;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemCond_Cond;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemCond_Result;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemPageSetup;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItem1;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemAddPage;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemDeletePage;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemDimensions;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemDimension;
		private Syncfusion.Windows.Forms.Diagram.Samples.OrgChart.clsLayoutManager pclsLayoutManager;
		private InsertSymbolTool insSymbolTool = null;

		[STAThread]
		static void Main() 
		{
			Application.Run(new frmDecisionTree());
		}

		public frmDecisionTree()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			string s=this.diagram.PageSettings.PaperSize.PaperName;
			this.diagram.PageSettings.Landscape=true;
			this.diagram.PageSettings.Margins.Left=0;
			this.diagram.PageSettings.Margins.Right=0;
			this.diagram.PageSettings.Margins.Top=0;
			this.diagram.PageSettings.Margins.Bottom=0;
			
			
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		protected Link CreateOrthogonalLink(PointF[] pts)
		{
			Link link = new Link(Link.Shapes.OrthogonalLine, pts);
			link.EndPoints.LastEndPointDecorator = new EndPointDecorator(EndPointVisuals.ClosedArrow);
			return link;
		}

		private const string YES_NO_LABEL_NAME="YesNo";
		private const string YES_VALUE="Yes";
		private const string NO_VALUE="No";
		private bool mDisplayYesNo=false;
		protected Link CreateLink(PointF[] pts)
		{
			Link link = new Link(Link.Shapes.Line, pts);
			link.EndPoints.LastEndPointDecorator = new EndPointDecorator(EndPointVisuals.ClosedArrow);
			// Links cannot be moved
			link.EditStyle.AllowMove = false;
			Label lblYesNo=link.AddLabel(YES_VALUE,50);  //default label
			lblYesNo.Visible=mDisplayYesNo;
			lblYesNo.FontStyle.Style = System.Drawing.FontStyle.Bold;
			lblYesNo.BackgroundStyle.Color=System.Drawing.Color.Transparent;
			lblYesNo.Name=YES_NO_LABEL_NAME;
			link.LineStyle.LineColor=Color.LimeGreen;
			link.FillStyle.Color=Color.LimeGreen;
			lblYesNo.FillStyle.Color=System.Drawing.Color.LimeGreen;

			this.diagram.View.SelectionList.Clear();

			return link;

		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(frmDecisionTree));
			this.panel1 = new System.Windows.Forms.Panel();
			this.diagram = new Syncfusion.Windows.Forms.Diagram.Controls.Diagram();
			this.pclsLayoutManager = new Syncfusion.Windows.Forms.Diagram.Samples.OrgChart.clsLayoutManager();
			this.mainFrameBarManager = new Syncfusion.Windows.Forms.Tools.XPMenus.MainFrameBarManager(this.components, this);
			this.bar2 = new Syncfusion.Windows.Forms.Tools.XPMenus.Bar(this.mainFrameBarManager, "Actions");
			this.barItemSelectTool = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.barItemAddCondition = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.barItemAddAlternative = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.barItemCond_Cond = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.barItemCond_Result = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.barItemLink = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.barItemZoomTool = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.smBarItemImages = new System.Windows.Forms.ImageList(this.components);
			this.barItemPan = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.barItemUpdateLayout = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.barItemAutoLayout = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.barTest = new Syncfusion.Windows.Forms.Tools.XPMenus.Bar(this.mainFrameBarManager, "Test");
			this.barItemNodeInfo = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.imageList1 = new System.Windows.Forms.ImageList(this.components);
			this.barItemAutoAdd = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.barItem1 = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.barItemShowTitle = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.barFile = new Syncfusion.Windows.Forms.Tools.XPMenus.Bar(this.mainFrameBarManager, "FileBar");
			this.barItemNew = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.barItemOpen = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.barItemSave = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.barItemPageSetup = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.barItemPreview = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.barItemPrint = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.barItemAddPage = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.barItemDeletePage = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.barItemDimension = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.barItemFileExit = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.barEdit = new Syncfusion.Windows.Forms.Tools.XPMenus.Bar(this.mainFrameBarManager, "EditBar");
			this.barItemEditCopy = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.barItemEditPaste = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.barItemEditCut = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.barItemDelete = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.barItemUndo = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.barItemRedo = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.parentBarItemFile = new Syncfusion.Windows.Forms.Tools.XPMenus.ParentBarItem();
			this.barItemSaveAs = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.barItemEditCondition = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.barItemDispDesc = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.barItemDispCond = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.barItemEditAlternative = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.barItemDispAlterCode = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.barItemDispAlterDesc = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.barItemEditLink = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.popSymbolParent = new Syncfusion.Windows.Forms.Tools.XPMenus.ParentBarItem();
			this.barItemDisplayYesNo = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.barItemHideYesNo = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.popSymbol = new Syncfusion.Windows.Forms.Tools.XPMenus.PopupMenu(this.components);
			this.parentBarItem3 = new Syncfusion.Windows.Forms.Tools.XPMenus.ParentBarItem();
			this.openDiagramDialog = new System.Windows.Forms.OpenFileDialog();
			this.saveDiagramDialog = new System.Windows.Forms.SaveFileDialog();
			this.barItemDimensions = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.panel1.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.mainFrameBarManager)).BeginInit();
			this.SuspendLayout();
			// 
			// panel1
			// 
			this.panel1.Controls.Add(this.diagram);
			this.panel1.Dock = System.Windows.Forms.DockStyle.Fill;
			this.panel1.Location = new System.Drawing.Point(0, 26);
			this.panel1.Name = "panel1";
			this.panel1.Size = new System.Drawing.Size(816, 435);
			this.panel1.TabIndex = 2;
			// 
			// diagram
			// 
			this.diagram.AllowDrop = true;
			// 
			// diagram.Controller
			// 
			this.diagram.Controller.MaxHistory = 256;
			this.diagram.Controller.ToolDeactivate += new Syncfusion.Windows.Forms.Diagram.Controller.ToolEventHandler(this.diagram_Controller_ToolDeactivate);
			this.diagram.Dock = System.Windows.Forms.DockStyle.Fill;
			this.diagram.HScroll = true;
			this.diagram.LayoutManager = this.pclsLayoutManager;
			this.diagram.Location = new System.Drawing.Point(0, 0);
			// 
			// diagram.Model
			// 
			this.diagram.Model.BackgroundStyle.Color = System.Drawing.Color.White;
			this.diagram.Model.BackgroundStyle.GradientAngle = 90F;
			this.diagram.Model.BackgroundStyle.GradientBounds = ((System.Drawing.RectangleF)(resources.GetObject("diagram.Model.BackgroundStyle.GradientBounds")));
			this.diagram.Model.BackgroundStyle.GradientStartColor = System.Drawing.Color.White;
			this.diagram.Model.BackgroundStyle.Properties = this.diagram.Model;
			this.diagram.Model.BackgroundStyle.Texture = null;
			this.diagram.Model.BackgroundStyle.TextureWrapMode = System.Drawing.Drawing2D.WrapMode.Tile;
			this.diagram.Model.BackgroundStyle.Type = Syncfusion.Windows.Forms.Diagram.BackgroundStyle.BackgroundType.Solid;
			this.diagram.Model.BoundaryConstraintsEnabled = true;
			this.diagram.Model.FillStyle.AlphaFactor = 255;
			this.diagram.Model.FillStyle.Color = System.Drawing.Color.LightGray;
			this.diagram.Model.FillStyle.GradientAngle = 90F;
			this.diagram.Model.FillStyle.GradientBounds = ((System.Drawing.RectangleF)(resources.GetObject("diagram.Model.FillStyle.GradientBounds")));
			this.diagram.Model.FillStyle.GradientStartColor = System.Drawing.Color.LightGray;
			this.diagram.Model.FillStyle.Properties = this.diagram.Model;
			this.diagram.Model.FillStyle.Texture = null;
			this.diagram.Model.FillStyle.TextureWrapMode = System.Drawing.Drawing2D.WrapMode.Tile;
			this.diagram.Model.FillStyle.Type = Syncfusion.Windows.Forms.Diagram.FillStyle.FillType.Solid;
			this.diagram.Model.Height = 1056F;
			this.diagram.Model.LineStyle.DashCap = System.Drawing.Drawing2D.DashCap.Flat;
			this.diagram.Model.LineStyle.DashOffset = 0F;
			this.diagram.Model.LineStyle.DashStyle = System.Drawing.Drawing2D.DashStyle.Solid;
			this.diagram.Model.LineStyle.EndCap = System.Drawing.Drawing2D.LineCap.Flat;
			this.diagram.Model.LineStyle.LineColor = System.Drawing.Color.Black;
			this.diagram.Model.LineStyle.LineJoin = System.Drawing.Drawing2D.LineJoin.Bevel;
			this.diagram.Model.LineStyle.LineWidth = 2F;
			this.diagram.Model.LineStyle.MiterLimit = 10F;
			this.diagram.Model.LineStyle.Properties = this.diagram.Model;
			this.diagram.Model.MeasurementScale = 1F;
			this.diagram.Model.MeasurementUnits = System.Drawing.GraphicsUnit.Pixel;
			this.diagram.Model.Name = "Model";
			this.diagram.Model.RenderingStyle.Properties = this.diagram.Model;
			this.diagram.Model.RenderingStyle.SmoothingMode = System.Drawing.Drawing2D.SmoothingMode.Default;
			this.diagram.Model.ShadowStyle.AlphaFactor = 128;
			this.diagram.Model.ShadowStyle.Color = System.Drawing.Color.LightGray;
			this.diagram.Model.ShadowStyle.OffsetX = 6F;
			this.diagram.Model.ShadowStyle.OffsetY = 6F;
			this.diagram.Model.ShadowStyle.Properties = this.diagram.Model;
			this.diagram.Model.ShadowStyle.Visible = false;
			this.diagram.Model.Width = 816F;
			this.diagram.Model.BoundsChanged += new Syncfusion.Windows.Forms.Diagram.BoundsEventHandler(this.diagram_Model_BoundsChanged);
			this.diagram.Model.PropertyChanged += new Syncfusion.Windows.Forms.Diagram.PropertyEventHandler(this.diagram_Model_PropertyChanged);
			this.diagram.Name = "diagram";
			this.diagram.NudgeIncrement = 1F;
			this.diagram.ScrollGranularity = 0.5F;
			this.diagram.Size = new System.Drawing.Size(816, 435);
			this.diagram.SmartSizeBox = false;
			this.diagram.TabIndex = 1;
			this.diagram.Text = "OrgChart Diagram";
			// 
			// diagram.View
			// 
			this.diagram.View.BackgroundColor = System.Drawing.Color.DarkGray;
			this.diagram.View.Grid.Color = System.Drawing.Color.Black;
			this.diagram.View.Grid.DashOffset = 4F;
			this.diagram.View.Grid.DashStyle = System.Drawing.Drawing2D.DashStyle.Dash;
			this.diagram.View.Grid.GridStyle = Syncfusion.Windows.Forms.Diagram.GridStyle.Point;
			this.diagram.View.Grid.HorizontalSpacing = 10F;
			this.diagram.View.Grid.SnapToGrid = true;
			this.diagram.View.Grid.VerticalSpacing = 10F;
			this.diagram.View.Grid.Visible = true;
			this.diagram.View.HandleAnchorColor = System.Drawing.Color.LightGray;
			this.diagram.View.HandleColor = System.Drawing.Color.White;
			this.diagram.View.HandleDisabledColor = System.Drawing.Color.Black;
			this.diagram.View.HandleSize = 6;
			this.diagram.View.HorizontalRuler.Visible = false;
			this.diagram.View.MouseTrackingEnabled = true;
			this.diagram.View.PasteOffsetX = 10;
			this.diagram.View.PasteOffsetY = 10;
			this.diagram.View.RulerFillColor = System.Drawing.Color.LightGray;
			this.diagram.View.RulerLineColor = System.Drawing.Color.Black;
			this.diagram.View.RulerSize = 16;
			this.diagram.View.RulerUnits = Syncfusion.Windows.Forms.Diagram.MeasurementsUnit.Inches;
			this.diagram.View.ShowPageBounds = true;
			this.diagram.View.VerticalRuler.Visible = false;
			this.diagram.VScroll = true;
			this.diagram.Resize += new System.EventHandler(this.diagram_Resize);
			this.diagram.MouseLeave += new System.EventHandler(this.diagram_MouseLeave);
			this.diagram.MouseDown += new System.Windows.Forms.MouseEventHandler(this.diagram_MouseDown);
			this.diagram.MouseUp += new System.Windows.Forms.MouseEventHandler(this.diagram_MouseUp);
			this.diagram.MouseEnter += new System.EventHandler(this.diagram_MouseEnter);
			// 
			// pclsLayoutManager
			// 
			this.pclsLayoutManager.AutoLayout = false;
			this.pclsLayoutManager.HorizontalSpacing = 200F;
			this.pclsLayoutManager.VerticalSpacing = 140F;
			// 
			// mainFrameBarManager
			// 
			this.mainFrameBarManager.BarPositionInfo = ((System.IO.MemoryStream)(resources.GetObject("mainFrameBarManager.BarPositionInfo")));
			this.mainFrameBarManager.Bars.Add(this.bar2);
			this.mainFrameBarManager.Bars.Add(this.barTest);
			this.mainFrameBarManager.Bars.Add(this.barFile);
			this.mainFrameBarManager.Bars.Add(this.barEdit);
			this.mainFrameBarManager.Categories.Add("Actions");
			this.mainFrameBarManager.Categories.Add("File");
			this.mainFrameBarManager.Categories.Add("Edit");
			this.mainFrameBarManager.Categories.Add("Information");
			this.mainFrameBarManager.Categories.Add("ConditionSymbol");
			this.mainFrameBarManager.Categories.Add("AlternativeSymbol");
			this.mainFrameBarManager.Categories.Add("Link");
			this.mainFrameBarManager.CurrentBaseFormType = "System.Windows.Forms.Form";
			this.mainFrameBarManager.Form = this;
			this.mainFrameBarManager.ImageList = this.imageList1;
			this.mainFrameBarManager.Items.AddRange(new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem[] {
																											 this.barItemLink,
																											 this.barItemUpdateLayout,
																											 this.barItemFileExit,
																											 this.parentBarItemFile,
																											 this.barItemSelectTool,
																											 this.barItemAutoLayout,
																											 this.barItemEditCut,
																											 this.barItemEditCopy,
																											 this.barItemEditPaste,
																											 this.barItemNodeInfo,
																											 this.barItemAutoAdd,
																											 this.barItemShowTitle,
																											 this.barItemAddCondition,
																											 this.barItemAddAlternative,
																											 this.barItemZoomTool,
																											 this.barItemEditCondition,
																											 this.barItemDispDesc,
																											 this.barItemDispCond,
																											 this.barItemEditAlternative,
																											 this.barItemDispAlterCode,
																											 this.barItemDispAlterDesc,
																											 this.barItemSave,
																											 this.barItemSaveAs,
																											 this.barItemOpen,
																											 this.barItemEditLink,
																											 this.barItemDelete,
																											 this.popSymbolParent,
																											 this.barItemDisplayYesNo,
																											 this.barItemHideYesNo,
																											 this.barItemNew,
																											 this.barItemPan,
																											 this.barItemUndo,
																											 this.barItemRedo,
																											 this.barItemPrint,
																											 this.barItemPreview,
																											 this.barItemCond_Cond,
																											 this.barItemCond_Result,
																											 this.barItemPageSetup,
																											 this.barItem1,
																											 this.barItemAddPage,
																											 this.barItemDeletePage,
																											 this.barItemDimension});
			this.mainFrameBarManager.LargeImageList = null;
			this.mainFrameBarManager.ResetCustomization = false;
			// 
			// bar2
			// 
			this.bar2.BarName = "Actions";
			this.bar2.Items.AddRange(new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem[] {
																							  this.barItemSelectTool,
																							  this.barItemAddCondition,
																							  this.barItemAddAlternative,
																							  this.barItemCond_Cond,
																							  this.barItemCond_Result,
																							  this.barItemLink,
																							  this.barItemZoomTool,
																							  this.barItemPan,
																							  this.barItemUpdateLayout,
																							  this.barItemAutoLayout});
			this.bar2.Manager = this.mainFrameBarManager;
			// 
			// barItemSelectTool
			// 
			this.barItemSelectTool.CategoryIndex = 0;
			this.barItemSelectTool.ID = "Select";
			this.barItemSelectTool.ImageIndex = 0;
			this.barItemSelectTool.Text = "Select";
			this.barItemSelectTool.Tooltip = "Select Tool";
			this.barItemSelectTool.Click += new System.EventHandler(this.barItemSelectTool_Click);
			// 
			// barItemAddCondition
			// 
			this.barItemAddCondition.CategoryIndex = 3;
			this.barItemAddCondition.ID = "Add Condition";
			this.barItemAddCondition.ImageIndex = 24;
			this.barItemAddCondition.Text = "Add Condition";
			this.barItemAddCondition.Click += new System.EventHandler(this.barItemAddCondition_Click);
			// 
			// barItemAddAlternative
			// 
			this.barItemAddAlternative.CategoryIndex = 3;
			this.barItemAddAlternative.ID = "Add Alternative";
			this.barItemAddAlternative.ImageIndex = 25;
			this.barItemAddAlternative.Text = "Add Result";
			this.barItemAddAlternative.Click += new System.EventHandler(this.barItemAddAlternative_Click);
			// 
			// barItemCond_Cond
			// 
			this.barItemCond_Cond.CategoryIndex = 0;
			this.barItemCond_Cond.ID = "Add Condition--Condition";
			this.barItemCond_Cond.ImageIndex = 26;
			this.barItemCond_Cond.Text = "Add Condition--Condition";
			this.barItemCond_Cond.Tooltip = "Add Condition---Condition";
			this.barItemCond_Cond.Click += new System.EventHandler(this.barItemCond_Cond_Click);
			// 
			// barItemCond_Result
			// 
			this.barItemCond_Result.CategoryIndex = 0;
			this.barItemCond_Result.ID = "Add Cond--Result";
			this.barItemCond_Result.ImageIndex = 27;
			this.barItemCond_Result.Text = "Add Cond--Result";
			this.barItemCond_Result.Tooltip = "Add Condition---Result";
			this.barItemCond_Result.Click += new System.EventHandler(this.barItemCond_Result_Click);
			// 
			// barItemLink
			// 
			this.barItemLink.CategoryIndex = 0;
			this.barItemLink.ID = "Link";
			this.barItemLink.ImageIndex = 4;
			this.barItemLink.Text = "Link";
			this.barItemLink.Tooltip = "Add Link";
			this.barItemLink.Click += new System.EventHandler(this.barItemLink_Click);
			// 
			// barItemZoomTool
			// 
			this.barItemZoomTool.CategoryIndex = 3;
			this.barItemZoomTool.ID = "ZoomTool";
			this.barItemZoomTool.ImageIndex = 17;
			this.barItemZoomTool.ImageList = this.smBarItemImages;
			this.barItemZoomTool.Tag = "ZoomTool";
			this.barItemZoomTool.Text = "ZoomTool";
			this.barItemZoomTool.Click += new System.EventHandler(this.barItemZoomTool_Click);
			// 
			// smBarItemImages
			// 
			this.smBarItemImages.ImageSize = new System.Drawing.Size(16, 16);
			this.smBarItemImages.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("smBarItemImages.ImageStream")));
			this.smBarItemImages.TransparentColor = System.Drawing.Color.Fuchsia;
			// 
			// barItemPan
			// 
			this.barItemPan.CategoryIndex = 3;
			this.barItemPan.ID = "Pan";
			this.barItemPan.ImageIndex = 16;
			this.barItemPan.ImageList = this.smBarItemImages;
			this.barItemPan.Text = "Pan";
			this.barItemPan.Click += new System.EventHandler(this.barItemPan_Click);
			// 
			// barItemUpdateLayout
			// 
			this.barItemUpdateLayout.CategoryIndex = 0;
			this.barItemUpdateLayout.ID = "Update Layout";
			this.barItemUpdateLayout.ImageIndex = 5;
			this.barItemUpdateLayout.Text = "Update Layout";
			this.barItemUpdateLayout.Click += new System.EventHandler(this.barItemUpdateLayout_Click);
			// 
			// barItemAutoLayout
			// 
			this.barItemAutoLayout.CategoryIndex = 0;
			this.barItemAutoLayout.ID = "AutoLayout";
			this.barItemAutoLayout.ImageIndex = 2;
			this.barItemAutoLayout.Text = "AutoLayout";
			this.barItemAutoLayout.Tooltip = "Auto Layout";
			this.barItemAutoLayout.Click += new System.EventHandler(this.barItemAutoLayout_Click);
			// 
			// barTest
			// 
			this.barTest.BarName = "Test";
			this.barTest.Items.AddRange(new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem[] {
																								 this.barItemNodeInfo,
																								 this.barItemAutoAdd,
																								 this.barItem1,
																								 this.barItemShowTitle});
			this.barTest.Manager = this.mainFrameBarManager;
			// 
			// barItemNodeInfo
			// 
			this.barItemNodeInfo.CategoryIndex = 3;
			this.barItemNodeInfo.ID = "NodeInfo";
			this.barItemNodeInfo.ImageIndex = 20;
			this.barItemNodeInfo.LargeImageList = this.imageList1;
			this.barItemNodeInfo.Text = "Actvie Node Info";
			this.barItemNodeInfo.Tooltip = "Node Information...";
			this.barItemNodeInfo.Click += new System.EventHandler(this.barItemNodeInfo_Click);
			// 
			// imageList1
			// 
			this.imageList1.ImageSize = new System.Drawing.Size(16, 16);
			this.imageList1.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("imageList1.ImageStream")));
			this.imageList1.TransparentColor = System.Drawing.Color.Fuchsia;
			// 
			// barItemAutoAdd
			// 
			this.barItemAutoAdd.CategoryIndex = 3;
			this.barItemAutoAdd.ID = "Wizard";
			this.barItemAutoAdd.ImageIndex = 28;
			this.barItemAutoAdd.Text = "Wizard";
			this.barItemAutoAdd.Tooltip = "Create a balanced tree...";
			this.barItemAutoAdd.Click += new System.EventHandler(this.barItemAutoAdd_Click);
			// 
			// barItem1
			// 
			this.barItem1.CategoryIndex = 3;
			this.barItem1.ID = "Validate Tree";
			this.barItem1.ImageIndex = 29;
			this.barItem1.Text = "Validate Tree";
			// 
			// barItemShowTitle
			// 
			this.barItemShowTitle.CategoryIndex = 3;
			this.barItemShowTitle.ID = "Run Analysis...";
			this.barItemShowTitle.ImageIndex = 22;
			this.barItemShowTitle.Text = "Run Sect Altertives...";
			this.barItemShowTitle.Tooltip = "Run Analysis...";
			this.barItemShowTitle.Click += new System.EventHandler(this.barItemShowTitle_Click);
			// 
			// barFile
			// 
			this.barFile.BarName = "FileBar";
			this.barFile.Items.AddRange(new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem[] {
																								 this.barItemNew,
																								 this.barItemOpen,
																								 this.barItemSave,
																								 this.barItemPageSetup,
																								 this.barItemPreview,
																								 this.barItemPrint,
																								 this.barItemAddPage,
																								 this.barItemDeletePage,
																								 this.barItemDimension,
																								 this.barItemFileExit});
			this.barFile.Manager = this.mainFrameBarManager;
			// 
			// barItemNew
			// 
			this.barItemNew.CategoryIndex = 1;
			this.barItemNew.ID = "New";
			this.barItemNew.ImageIndex = 11;
			this.barItemNew.Text = "New";
			this.barItemNew.Click += new System.EventHandler(this.barItemNew_Click);
			// 
			// barItemOpen
			// 
			this.barItemOpen.CategoryIndex = 1;
			this.barItemOpen.ID = "Open...";
			this.barItemOpen.ImageIndex = 12;
			this.barItemOpen.Text = "Open...";
			this.barItemOpen.Click += new System.EventHandler(this.barItemOpen_Click);
			// 
			// barItemSave
			// 
			this.barItemSave.CategoryIndex = 1;
			this.barItemSave.ID = "Save";
			this.barItemSave.ImageIndex = 13;
			this.barItemSave.Text = "Save...";
			this.barItemSave.Click += new System.EventHandler(this.barItemSave_Click);
			// 
			// barItemPageSetup
			// 
			this.barItemPageSetup.CategoryIndex = 1;
			this.barItemPageSetup.ID = "Page Setup";
			this.barItemPageSetup.ImageIndex = 23;
			this.barItemPageSetup.Text = "Page Setup";
			this.barItemPageSetup.Tooltip = "Page Setup...";
			this.barItemPageSetup.Click += new System.EventHandler(this.barItemPageSetup_Click);
			// 
			// barItemPreview
			// 
			this.barItemPreview.CategoryIndex = 1;
			this.barItemPreview.ID = "Preview";
			this.barItemPreview.ImageIndex = 15;
			this.barItemPreview.Text = "Preview...";
			this.barItemPreview.Click += new System.EventHandler(this.barItemPreview_Click);
			// 
			// barItemPrint
			// 
			this.barItemPrint.CategoryIndex = 1;
			this.barItemPrint.ID = "Print";
			this.barItemPrint.ImageIndex = 14;
			this.barItemPrint.Text = "Print...";
			this.barItemPrint.Click += new System.EventHandler(this.barItemPrint_Click);
			// 
			// barItemAddPage
			// 
			this.barItemAddPage.CategoryIndex = 1;
			this.barItemAddPage.ID = "Increase Page";
			this.barItemAddPage.ImageIndex = 31;
			this.barItemAddPage.Text = "Add a Page";
			this.barItemAddPage.Click += new System.EventHandler(this.barItemAddPage_Click);
			// 
			// barItemDeletePage
			// 
			this.barItemDeletePage.CategoryIndex = 1;
			this.barItemDeletePage.ID = "Decrease Page";
			this.barItemDeletePage.ImageIndex = 30;
			this.barItemDeletePage.Text = "Remove a Page";
			this.barItemDeletePage.Click += new System.EventHandler(this.barItemDeletePage_Click);
			// 
			// barItemDimension
			// 
			this.barItemDimension.CategoryIndex = 1;
			this.barItemDimension.ID = "Diagram Dimession";
			this.barItemDimension.ImageIndex = 3;
			this.barItemDimension.Text = "Change Diagram Dimension";
			this.barItemDimension.Click += new System.EventHandler(this.barItemDimension_Click);
			// 
			// barItemFileExit
			// 
			this.barItemFileExit.CategoryIndex = 1;
			this.barItemFileExit.ID = "Exit";
			this.barItemFileExit.ImageIndex = 10;
			this.barItemFileExit.Text = "Exit";
			this.barItemFileExit.Click += new System.EventHandler(this.barItemFileExit_Click);
			// 
			// barEdit
			// 
			this.barEdit.BarName = "EditBar";
			this.barEdit.Items.AddRange(new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem[] {
																								 this.barItemEditCopy,
																								 this.barItemEditPaste,
																								 this.barItemEditCut,
																								 this.barItemDelete,
																								 this.barItemUndo,
																								 this.barItemRedo});
			this.barEdit.Manager = this.mainFrameBarManager;
			// 
			// barItemEditCopy
			// 
			this.barItemEditCopy.CategoryIndex = 2;
			this.barItemEditCopy.ID = "Copy";
			this.barItemEditCopy.ImageIndex = 7;
			this.barItemEditCopy.Shortcut = System.Windows.Forms.Shortcut.CtrlC;
			this.barItemEditCopy.Text = "&Copy";
			this.barItemEditCopy.Click += new System.EventHandler(this.barItemEditCopy_Click);
			// 
			// barItemEditPaste
			// 
			this.barItemEditPaste.CategoryIndex = 2;
			this.barItemEditPaste.ID = "Paste";
			this.barItemEditPaste.ImageIndex = 8;
			this.barItemEditPaste.Shortcut = System.Windows.Forms.Shortcut.CtrlV;
			this.barItemEditPaste.Text = "&Paste";
			this.barItemEditPaste.Click += new System.EventHandler(this.barItemEditPaste_Click);
			// 
			// barItemEditCut
			// 
			this.barItemEditCut.CategoryIndex = 2;
			this.barItemEditCut.ID = "Cut";
			this.barItemEditCut.ImageIndex = 6;
			this.barItemEditCut.Shortcut = System.Windows.Forms.Shortcut.CtrlX;
			this.barItemEditCut.Text = "Cu&t";
			this.barItemEditCut.Click += new System.EventHandler(this.barItemEditCut_Click);
			// 
			// barItemDelete
			// 
			this.barItemDelete.CategoryIndex = 2;
			this.barItemDelete.ID = "Delete";
			this.barItemDelete.ImageIndex = 9;
			this.barItemDelete.Shortcut = System.Windows.Forms.Shortcut.Del;
			this.barItemDelete.Text = "Delete";
			this.barItemDelete.Click += new System.EventHandler(this.barItemDelete_Click);
			// 
			// barItemUndo
			// 
			this.barItemUndo.CategoryIndex = 2;
			this.barItemUndo.ID = "Undo";
			this.barItemUndo.ImageIndex = 16;
			this.barItemUndo.Shortcut = System.Windows.Forms.Shortcut.CtrlZ;
			this.barItemUndo.Text = "Undo";
			this.barItemUndo.Tooltip = "Undo";
			this.barItemUndo.Click += new System.EventHandler(this.barItemUndo_Click);
			// 
			// barItemRedo
			// 
			this.barItemRedo.CategoryIndex = 2;
			this.barItemRedo.ID = "Redo";
			this.barItemRedo.ImageIndex = 17;
			this.barItemRedo.Shortcut = System.Windows.Forms.Shortcut.CtrlY;
			this.barItemRedo.Text = "Redo";
			this.barItemRedo.Tooltip = "Redo";
			this.barItemRedo.Click += new System.EventHandler(this.barItemRedo_Click);
			// 
			// parentBarItemFile
			// 
			this.parentBarItemFile.CategoryIndex = 1;
			this.parentBarItemFile.ID = "File";
			this.parentBarItemFile.Items.AddRange(new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem[] {
																										   this.barItemOpen,
																										   this.barItemSave,
																										   this.barItemSaveAs,
																										   this.barItemFileExit});
			this.parentBarItemFile.Text = "File";
			// 
			// barItemSaveAs
			// 
			this.barItemSaveAs.CategoryIndex = 1;
			this.barItemSaveAs.ID = "SaveAs";
			this.barItemSaveAs.Text = "SaveAs";
			this.barItemSaveAs.Click += new System.EventHandler(this.barItemSaveAs_Click);
			// 
			// barItemEditCondition
			// 
			this.barItemEditCondition.CategoryIndex = 4;
			this.barItemEditCondition.ID = "Edit...";
			this.barItemEditCondition.Text = "Edit...";
			this.barItemEditCondition.Click += new System.EventHandler(this.barItemEditCondition_Click);
			// 
			// barItemDispDesc
			// 
			this.barItemDispDesc.CategoryIndex = 4;
			this.barItemDispDesc.ID = "Display Description";
			this.barItemDispDesc.Text = "Display Description";
			this.barItemDispDesc.Click += new System.EventHandler(this.barItemDispDesc_Click);
			// 
			// barItemDispCond
			// 
			this.barItemDispCond.CategoryIndex = 4;
			this.barItemDispCond.ID = "Display Condition";
			this.barItemDispCond.Text = "Display Condition";
			this.barItemDispCond.Click += new System.EventHandler(this.barItemDispCond_Click);
			// 
			// barItemEditAlternative
			// 
			this.barItemEditAlternative.CategoryIndex = 5;
			this.barItemEditAlternative.ID = "Edit..._1";
			this.barItemEditAlternative.Text = "Edit...";
			this.barItemEditAlternative.Click += new System.EventHandler(this.barItemEditAlternative_Click);
			// 
			// barItemDispAlterCode
			// 
			this.barItemDispAlterCode.CategoryIndex = 5;
			this.barItemDispAlterCode.ID = "Display Code";
			this.barItemDispAlterCode.Text = "Display Code";
			this.barItemDispAlterCode.Click += new System.EventHandler(this.barItemDispAlterCode_Click);
			// 
			// barItemDispAlterDesc
			// 
			this.barItemDispAlterDesc.CategoryIndex = 5;
			this.barItemDispAlterDesc.ID = "Display Description_1";
			this.barItemDispAlterDesc.Text = "Display Description";
			this.barItemDispAlterDesc.Click += new System.EventHandler(this.barItemDispAlterDesc_Click);
			// 
			// barItemEditLink
			// 
			this.barItemEditLink.CategoryIndex = 6;
			this.barItemEditLink.ID = "Edit..._2";
			this.barItemEditLink.Text = "Edit...";
			this.barItemEditLink.Click += new System.EventHandler(this.barItemEditLink_Click);
			// 
			// popSymbolParent
			// 
			this.popSymbolParent.CategoryIndex = 2;
			this.popSymbolParent.ID = "popSymbolParent";
			this.popSymbolParent.Text = "popSymbolParent";
			// 
			// barItemDisplayYesNo
			// 
			this.barItemDisplayYesNo.CategoryIndex = 6;
			this.barItemDisplayYesNo.ID = "Display Yes/No Label";
			this.barItemDisplayYesNo.Text = "Display Yes/No Label";
			this.barItemDisplayYesNo.Click += new System.EventHandler(this.barItemDisplayYesNo_Click);
			// 
			// barItemHideYesNo
			// 
			this.barItemHideYesNo.CategoryIndex = 6;
			this.barItemHideYesNo.ID = "Hide Yes/No Label";
			this.barItemHideYesNo.Text = "Hide Yes/No Label";
			this.barItemHideYesNo.Click += new System.EventHandler(this.barItemHideYesNo_Click);
			// 
			// popSymbol
			// 
			this.popSymbol.ParentBarItem = this.popSymbolParent;
			// 
			// parentBarItem3
			// 
			this.parentBarItem3.CategoryIndex = -1;
			this.parentBarItem3.ID = "";
			// 
			// openDiagramDialog
			// 
			this.openDiagramDialog.Filter = "Diagram Files|*.edd|All files|*.*";
			this.openDiagramDialog.Title = "Open Diagram";
			// 
			// saveDiagramDialog
			// 
			this.saveDiagramDialog.FileName = "doc1";
			this.saveDiagramDialog.Filter = "Diagram files|*.edd|All files|*.*";
			// 
			// barItemDimensions
			// 
			this.barItemDimensions.CategoryIndex = 0;
			this.barItemDimensions.ID = "Dimensions";
			this.barItemDimensions.ImageIndex = 3;
			this.barItemDimensions.ImageList = this.imageList1;
			this.barItemDimensions.Text = "Dimensions";
			this.barItemDimensions.Click += new System.EventHandler(this.barItemDimension_Click);
			// 
			// frmDecisionTree
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(816, 461);
			this.Controls.Add(this.panel1);
			this.Name = "frmDecisionTree";
			this.SizeGripStyle = System.Windows.Forms.SizeGripStyle.Show;
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Text = "Organizational Chart";
			this.Resize += new System.EventHandler(this.MainForm_Resize);
			this.Load += new System.EventHandler(this.MainForm_Load);
			this.panel1.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.mainFrameBarManager)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		

		private void RegisterCustomTools()
		{
			this.diagram.Controller.RegisterTool(new InsertSymbolTool("InsertCondition", typeof(clsConditionSymbol)));

			this.insSymbolTool = new InsertSymbolTool("InsertSymbol", typeof(tmpSymbol));
			this.diagram.Controller.RegisterTool(this.insSymbolTool);
			

			// Attach link object factory to the link tool
			Tool linkTool = this.diagram.Controller.GetTool("LinkTool");
			if (linkTool != null && linkTool.GetType() == typeof(LinkTool))
			{
				#if false
								((LinkTool)linkTool).LinkFactory = new LinkFactory(this.CreateOrthogonalLink);
				#else
								((LinkTool)linkTool).LinkFactory = new LinkFactory(this.CreateLink);
				#endif
			}

			this.barItemAutoLayout.Checked = this.pclsLayoutManager.AutoLayout;

		}

		private const float NODE_WIDTH=80.0f;
		private const float NODE_SPACE=10.0f;
		private const float DEFAULT_PAGES=1.0f;
		private void MainForm_Load(object sender, System.EventArgs e)
		{
			RegisterCustomTools();
			SetModelOrinialSize();
			//this.diagram.View.Update();
//			this.diagram.Model.Width=this.diagram.PageSettings.PaperSize.Width*4;//32*(NODE_WIDTH+NODE_SPACE);
//			this.diagram.Model.Height=this.diagram.PageSettings.PaperSize.Height;
			
		}

		private void SetModelOrinialSize()
		{
			this.diagram.Model.Width=this.diagram.PageSettings.PaperSize.Width*DEFAULT_PAGES;
			this.diagram.Model.Height=this.diagram.PageSettings.PaperSize.Height*2.0f;

		}
		private void barItemLink_Click(object sender, System.EventArgs e)
		{
			this.diagram.ActivateTool("LinkTool");
		}

		private void barItemUpdateLayout_Click(object sender, System.EventArgs e)
		{
			this.diagram.LayoutManager.UpdateLayout(null);
			
		}



		private void barItemFileExit_Click(object sender, System.EventArgs e)
		{
			this.Close();
		}

		private void barItemSelectTool_Click(object sender, System.EventArgs e)
		{
			this.diagram.ActivateTool("SelectTool");
		}

		private void barItemAutoLayout_Click(object sender, System.EventArgs e)
		{
			if (this.barItemAutoLayout.Checked)
			{
				this.barItemAutoLayout.Checked = false;
			}
			else
			{
				this.barItemAutoLayout.Checked = true;
			}
			this.pclsLayoutManager.AutoLayout = this.barItemAutoLayout.Checked;
		}

		private void barItemEditCut_Click(object sender, System.EventArgs e)
		{
			this.diagram.Cut();
		}

		private void barItemEditCopy_Click(object sender, System.EventArgs e)
		{
			this.diagram.Copy();
		}

		private void barItemEditPaste_Click(object sender, System.EventArgs e)
		{
			this.diagram.Paste();
		}

		private void barItemDimension_Click(object sender, System.EventArgs e)
		{
			frmDimensionsDlg dlg = new frmDimensionsDlg();

			dlg.DiagramWidth = this.diagram.Model.Width;
			dlg.DiagramHeight = this.diagram.Model.Height;

			if (dlg.ShowDialog(this) == DialogResult.OK)
			{
				this.diagram.Model.Width = dlg.DiagramWidth;
				this.diagram.Model.Height = dlg.DiagramHeight;
			}
		}

		


		private void barItemNodeInfo_Click(object sender, System.EventArgs e)
		{
			if (this.diagram.SelectionList.Count > 0)
			{
				
				string sMsg="";
				INode pNode=this.diagram.SelectionList[0];
				if (pNode.Parent!=null)
				{
					sMsg="Parent Node: "+pNode.Parent.Name;
				}
				else
				{
					sMsg="Parent Node: "+"No";
				}


												
				sMsg=sMsg+"\r\nFull Name:"+pNode.FullName;
				
				clsAlternativeSymbol alterSym=pNode as clsAlternativeSymbol;
				if (alterSym!=null)
				{
					sMsg=sMsg+"\r\nAlternatives:";
					foreach(Label lbl in alterSym.Labels)
					{
						sMsg=sMsg+"\r\n"+lbl.Text;
					}
					sMsg=sMsg+"\r\nPorts";
					foreach (Port p in alterSym.Ports)
					{
						sMsg=sMsg+"\r\n"+p.FullName;
					}
					sMsg=sMsg+"\r\nConditions:";
					sMsg=sMsg+"\r\n"+alterSym.Condition;
					alterSym.SetPathColor(Color.BurlyWood);
					System.Threading.Thread.Sleep(1000);
					alterSym.ResetPathColor();

				}

				clsConditionSymbol condSym=pNode as clsConditionSymbol;
				if (condSym!=null)
				{
					sMsg=sMsg+"\r\nCondition:";
					Label lbl;
					lbl=condSym.GetChildByName("lblDesc") as Label;
					sMsg=sMsg+"\r\n"+ "Description: " + lbl.Text;
					lbl=condSym.GetChildByName("lblExpression") as Label;
					sMsg=sMsg+"\r\n"+ "Expression: " + lbl.Text;
					sMsg=sMsg+"\r\nConditions:";
					sMsg=sMsg+"\r\n"+condSym.Condition;
					condSym.SetPathColor(Color.BurlyWood);
					System.Threading.Thread.Sleep(1000);
					condSym.ResetPathColor();
					

				}
				
				Link lnk=pNode as Link;
				if (lnk!=null)
				{
					sMsg=sMsg+"\r\nCondition Link:";
					Label lbl;
					lbl=lnk.GetChildByName(YES_NO_LABEL_NAME) as Label;
					sMsg=sMsg+"\r\n"+ "Expression: " + lbl.Text;
				}
				MessageBox.Show(sMsg);
			}

		}



		

		private bool Condition(string Expression)
		{
			
			// *** Example form input has code in a text box 
			string lcCode = "return (" + Expression+");";

 

			ICodeCompiler loCompiler = new CSharpCodeProvider().CreateCompiler();

			CompilerParameters loParameters = new CompilerParameters();

 

			// *** Start by adding any referenced assemblies

			loParameters.ReferencedAssemblies.Add("System.dll");

			loParameters.ReferencedAssemblies.Add("System.Windows.Forms.dll");

			// *** Must create a fully functional assembly as a string

lcCode = @"
using System;
using System.IO;
using System.Windows.Forms;
namespace MyNamespace {
	public class MyClass {
		public bool DynamicCode(params object[] Parameters) {
					"  + lcCode + "}   }    }";

 

			// *** Load the resulting assembly into memory

			loParameters.GenerateInMemory = false;

   

			// *** Now compile the whole thing

			CompilerResults loCompiled =

				loCompiler.CompileAssemblyFromSource(loParameters,lcCode);

 

			if (loCompiled.Errors.HasErrors)    
			{

				string lcErrorMsg = "";

 

				lcErrorMsg = loCompiled.Errors.Count.ToString() + " Errors:";

				for (int x=0;x<loCompiled.Errors.Count;x++) 

					lcErrorMsg = lcErrorMsg  + "\r\nLine: " + 

						loCompiled.Errors[x].Line.ToString() + " - " +                          

						loCompiled.Errors[x].ErrorText;      

 

				MessageBox.Show(lcErrorMsg + "\r\n\r\n" + lcCode,

					"Compiler Demo");

				return false;

			}

 

			Assembly loAssembly = loCompiled.CompiledAssembly;

 

			// *** Retrieve an obj ref  generic type only

			object loObject  = loAssembly.CreateInstance("MyNamespace.MyClass");

			if (loObject == null) 
			{

				MessageBox.Show("Couldn't load class.");

				return false;

			}

 

			object[] loCodeParms = new object[1];

			loCodeParms[0] = "West Wind Technologies";

   

			try    
			{

				bool loResult =(bool) loObject.GetType().InvokeMember(

					"DynamicCode",BindingFlags.InvokeMethod,

					null,loObject,loCodeParms);

				return  loResult;


			}

			catch(Exception loError)    
			{

				MessageBox.Show(loError.Message,"Compiler Demo"); 
				return false;
			}

		}

 

		//private const Color  HIGHLIGHT_SYMBOL_COLOR=Color.BurlyWood; 
		public string ShowSectAlternatives(string AADT,string RCI,string SDI)
		{
			string sMsg="";
			foreach (INode curNode in this.diagram.Model.Nodes)
			{
				if (curNode.GetType() == typeof(clsAlternativeSymbol))
				{	
					clsAlternativeSymbol alterSym=curNode as clsAlternativeSymbol;
					if (alterSym!=null)
					{
						string sCond=alterSym.Condition; // "(AADT>5) AND (RCI<6) AND (SDI>8)"
						sCond=sCond.Replace("AADT",AADT);
						sCond=sCond.Replace("RCI",RCI);
						sCond=sCond.Replace("SDI",SDI);
						sCond=sCond.Replace("AND","&&");
						sCond=sCond.Replace("OR","||");
						sCond=sCond.Replace("NOT","!");

						if (Condition(sCond))
						{
						
							sMsg="Section Alternatives:";
							foreach(Label lbl in alterSym.Labels)
							{
								sMsg=sMsg+"\r\n"+lbl.Text;
							}
							sMsg=sMsg+"\r\nSection Conditions:";
							sMsg=sMsg+"\r\n"+alterSym.Condition;
							alterSym.SetPathColor(Color.BurlyWood);
							System.Threading.Thread.Sleep(1000);
							alterSym.ResetPathColor();
						}
					}
				}
			}
			return sMsg;

		}

		private void barItemAutoAdd_Click(object sender, System.EventArgs e)
		{
			frmTreeWizard frm=new frmTreeWizard();
			if (frm.ShowDialog()==DialogResult.OK)
			{
				int iLevel=frm.LevelNumber;
				if (iLevel==0) return;
				int TotalLeaf=1;
				for (int i=1;i<=iLevel;i++)
				{
					TotalLeaf=TotalLeaf*2;
				}
				float TreeWidth=(NODE_WIDTH+NODE_SPACE)*TotalLeaf;
				float TreeHigh=(iLevel+1)*this.verticalSpacing;

				if (TreeWidth>this.diagram.Model.Width)
				{
					this.diagram.Model.Width=TreeWidth;
					this.diagram.View.Update();
				}
				if (TreeHigh>this.diagram.Model.Height)
				{
					this.diagram.Model.Height=TreeHigh;
					this.diagram.View.Update();
				}
				float curLeft = this.diagram.Model.Bounds.Left;//this.Model.Bounds.Left;
				float curRight = curLeft + TreeWidth;//this.diagram.Model.Bounds.Right;//this.Model.Width;
				clsConditionSymbol condSym = new clsConditionSymbol();
				diagram.Model.AppendChild(condSym);
				condSym.Y = ((float) 1) * this.verticalSpacing;
				CreateTree(condSym,1,iLevel,curLeft,curRight,LeafNodeTypes.AlternativeSymbol);
				this.diagram.View.Update();

			}
	
			

		}

		public float VerticalSpacing
		{
			get
			{
				return this.verticalSpacing;
			}
			set
			{
				this.verticalSpacing = value;
			}
		}

		private float verticalSpacing = 100.0f;

		
		//private void PositionMember(tmpSymbol memberSym, float left, float right)
		private enum LeafNodeTypes {ConditionSymbol=1,AlternativeSymbol=2};

		private void CreateTree(clsConditionSymbol CurrNode,int CurrLevel,int TotalLevel,float left,float right,LeafNodeTypes LeafNodeType)
		{
			

			CreateNode(CurrNode,CurrLevel,TotalLevel, left, right,LeafNodeType);
			this.diagram.View.SelectionList.Clear();
			this.diagram.Focus();
			
		}
		private void CreateNode(clsConditionSymbol CurrNode,int CurrLevel,int TotalLevel,float left,float right,LeafNodeTypes LeafNodeType)
		{
			if (CurrLevel>TotalLevel) return;
			float symWidth = CurrNode.Width;
			float Center = (left + right) / 2.0f;
			CurrNode.X = Center - (symWidth / 2.0f);

			if (CurrLevel==TotalLevel)
			{
				float leafSymWidth;
				tmpSymbol LeftSym;
				tmpSymbol RightSym;
				if (LeafNodeType==LeafNodeTypes.AlternativeSymbol)
				{
					LeftSym=new clsAlternativeSymbol();
					RightSym=new clsAlternativeSymbol();
					leafSymWidth=LeftSym.Width;
				}
				else
				{
					LeftSym=new clsConditionSymbol();
					RightSym=new clsConditionSymbol();
					leafSymWidth=LeftSym.Width;

				}
				

				// set position
				
				LeftSym.Y = CurrNode.Y + this.verticalSpacing;
				LeftSym.X = (left+Center)/2.0f- (leafSymWidth / 2.0f);
				diagram.Model.AppendChild(LeftSym);
				RightSym.Y= CurrNode.Y + this.verticalSpacing;;
				RightSym.X=(Center+right)/2.0f- (leafSymWidth / 2.0f);
				diagram.Model.AppendChild(RightSym);

				// set linkLeft "Yes" link
				Link linkLeft = GetLink(true) ;//new Link(Link.Shapes.Line);
				CurrNode.Connect(CurrNode.CenterPort, linkLeft.TailPort);
				LeftSym.Connect(linkLeft.HeadPort,LeftSym.CenterPort);
				diagram.Model.AppendChild(linkLeft);
				// set linkRight "No" link
				Link linkRight =GetLink(false);// new Link(Link.Shapes.Line);
				CurrNode.Connect(CurrNode.CenterPort, linkRight.TailPort);
				RightSym.Connect(linkRight.HeadPort,RightSym.CenterPort);
				diagram.Model.AppendChild(linkRight);

				
			}
			else
			{
				
				float leafSymWidth;
				
				clsConditionSymbol LeftSym=new clsConditionSymbol();
				clsConditionSymbol RightSym=new clsConditionSymbol();
				leafSymWidth=LeftSym.Width;


				// set position
				float range = (right - left) /  2.0f;
				float curLeft = left;
				float curRight = (Left + right) / 2.0f;
				LeftSym.Y = CurrNode.Y + this.verticalSpacing;;
				LeftSym.X = (left+Center)/2.0f- (leafSymWidth / 2.0f);
				diagram.Model.AppendChild(LeftSym);
				RightSym.Y= CurrNode.Y + this.verticalSpacing;;
				RightSym.X=(Center+right)/2.0f- (leafSymWidth / 2.0f);
				diagram.Model.AppendChild(RightSym);

				// set linkLeft "Yes" link
				Link linkLeft = GetLink(true) ;//new Link(Link.Shapes.Line);
				CurrNode.Connect(CurrNode.CenterPort, linkLeft.TailPort);
				
				LeftSym.Connect(linkLeft.HeadPort,LeftSym.CenterPort);
				diagram.Model.AppendChild(linkLeft);
				// set linkRight "No" link
				Link linkRight =GetLink(false);// new Link(Link.Shapes.Line);
				CurrNode.Connect(CurrNode.CenterPort, linkRight.TailPort);
				RightSym.Connect(linkRight.HeadPort,RightSym.CenterPort);
				diagram.Model.AppendChild(linkRight);

				// do left node
				CreateTree(LeftSym,CurrLevel+1,TotalLevel,left,Center,LeafNodeTypes.AlternativeSymbol);
				// do right node
				CreateTree(RightSym,CurrLevel+1,TotalLevel,Center,right,LeafNodeTypes.AlternativeSymbol);


				

			}

			

		}

		private Link GetLink(bool IsYes)
		{
		
			Link link = new Link(Link.Shapes.Line);
			link.EndPoints.LastEndPointDecorator = new EndPointDecorator(EndPointVisuals.ClosedArrow);
			// Links cannot be moved
			link.EditStyle.AllowMove = false;
			Label lblYesNo=link.AddLabel("",50);  //default label
			lblYesNo.Visible=mDisplayYesNo;
			if (IsYes)
			{
				lblYesNo.Text=YES_VALUE;  //default label
				lblYesNo.FillStyle.Color=System.Drawing.Color.LimeGreen;
				link.LineStyle.LineColor=Color.LimeGreen;
				link.FillStyle.Color=Color.LimeGreen;

			}
			else
			{
				lblYesNo.Text=NO_VALUE;
				lblYesNo.FillStyle.Color=System.Drawing.Color.BurlyWood;
				link.LineStyle.LineColor=Color.BurlyWood;
				link.FillStyle.Color=Color.BurlyWood;
			}
			lblYesNo.FontStyle.Style = System.Drawing.FontStyle.Bold;
			lblYesNo.BackgroundStyle.Color=System.Drawing.Color.Transparent;
			lblYesNo.Name=YES_NO_LABEL_NAME;
			

			return link;

		}
		

		/// <summary>
		private void barItemNoText_Click(object sender, System.EventArgs e)
		{
		
		}

		private void barItemShowTitle_Click(object sender, System.EventArgs e)
		{
			frmSect frm=new frmSect();
			frm.CallBackForm=this;
			frm.Show();
		}

		private void barItemShowName_Click(object sender, System.EventArgs e)
		{
		
		}

		private void barItemAddCondition_Click(object sender, System.EventArgs e)
		{			
			//Commented Out
			//clsConditionSymbol condSym = new clsConditionSymbol();
			//this.insSymbolTool.Symbol = condSym;
this.diagram.Controller.RegisterTool(new InsertSymbolTool("InsertCondition", typeof(clsConditionSymbol)));
this.diagram.Controller.ActivateTool("InsertCondition");		
		}

		private void diagram_Model_PropertyChanged(object sender, Syncfusion.Windows.Forms.Diagram.PropertyEventArgs evtArgs)
		{
			diagram.View.Update();
		}

		private void barItemAddAlternative_Click(object sender, System.EventArgs e)
		{
		
			clsAlternativeSymbol alterSym =new clsAlternativeSymbol();
			this.insSymbolTool.Symbol = alterSym;
			this.diagram.Controller.ActivateTool(this.insSymbolTool);
		}
		

		private void diagram_Model_BoundsChanged(object sender, Syncfusion.Windows.Forms.Diagram.BoundsEventArgs evtArgs)
		{
			diagram.View.Update();
			
		}

		private clsConditionSymbol curConditionSymbol;
		private clsAlternativeSymbol curAlternativeSymbol;
		private Link curLink;
		private void diagram_MouseUp(object sender, System.Windows.Forms.MouseEventArgs e)
		{
			try
			{
				if(e.Button == MouseButtons.Right)
				{
					curConditionSymbol=null;
					curAlternativeSymbol=null;
					curLink=null;
					foreach (INode curNode in this.diagram.Controller.NodesHit)
					{
						if (curNode.GetType()==typeof(Link))
						{
							curLink=curNode as Link;
							Point ClickPoint = new Point(e.X,e.Y); 
							// Convert from Tree coordinates to Screen coordinates  
							Point ScreenPoint = this.diagram.PointToScreen(ClickPoint); 
							// Convert from Screen coordinates to Formc coordinates 
							Point FormPoint = this.PointToClient(ScreenPoint); 
							// Show context menu  
							popSymbolParent.Items.Clear();
							popSymbolParent.Items.Add(barItemEditLink);
							popSymbolParent.Items.Add(barItemDisplayYesNo);
							popSymbolParent.Items.Add(barItemHideYesNo);
							popSymbol.Show(this,FormPoint);

						}
						if (curNode.GetType() == typeof(clsConditionSymbol))
						{	
							curConditionSymbol=curNode as clsConditionSymbol;
							Point ClickPoint = new Point(e.X,e.Y); 
							// Convert from Tree coordinates to Screen coordinates  
							Point ScreenPoint = this.diagram.PointToScreen(ClickPoint); 
							// Convert from Screen coordinates to Formc coordinates 
							Point FormPoint = this.PointToClient(ScreenPoint); 
							// Show context menu  
							popSymbolParent.Items.Clear();
							popSymbolParent.Items.Add(barItemEditCondition);
							popSymbolParent.Items.Add(barItemDispDesc);
							popSymbolParent.Items.Add(barItemDispCond);
							popSymbol.Show(this,FormPoint);
						}
						if (curNode.GetType() == typeof(clsAlternativeSymbol))
						{	
							curAlternativeSymbol=curNode as clsAlternativeSymbol;
							Point ClickPoint = new Point(e.X,e.Y); 
							// Convert from Tree coordinates to Screen coordinates  
							Point ScreenPoint = this.diagram.PointToScreen(ClickPoint); 
							// Convert from Screen coordinates to Formc coordinates 
							Point FormPoint = this.PointToClient(ScreenPoint); 
							// Show context menu  
							// Show context menu  
							popSymbolParent.Items.Clear();
							popSymbolParent.Items.Add(barItemEditAlternative);
							popSymbolParent.Items.Add(barItemDispAlterCode);
							popSymbolParent.Items.Add(barItemDispAlterDesc);
							popSymbol.Show(this,FormPoint);
						}
					}
				
				}
			}
			catch 
			{
				// Here is error!!!
				//MessageBox.Show(exp.Message);
			}
		}

		private void barItemEditCondition_Click(object sender, System.EventArgs e)
		{
			frmConditionEdit dlg=new frmConditionEdit();
			if (dlg.ShowDialog(this) == DialogResult.OK)
			{
				string sCond = dlg.Condition;
				string sDesc=dlg.Description;
				if (curConditionSymbol!=null)
				{
					curConditionSymbol.Description=sDesc;
					curConditionSymbol.Expression=sCond;
					this.diagram.View.SelectionList.Clear();
					
				}
			}
		}

		private void barItemEditAlternative_Click(object sender, System.EventArgs e)
		{
			
			frmAlternativeEdit dlg=new frmAlternativeEdit();
			if (dlg.ShowDialog(this) == DialogResult.OK)
			{
				string sCode = dlg.Code;
				string sDesc=dlg.Description;
				if (curAlternativeSymbol!=null)
				{
					curAlternativeSymbol.AddItem(sCode,sDesc);
					this.diagram.View.SelectionList.Clear();
				}
			}
			
		}

		private void barItemDispAlterCode_Click(object sender, System.EventArgs e)
		{
//			foreach (INode curNode in this.diagram.Model.Nodes)
//			{
//				if (curNode.GetType() == typeof(AlternativeSymbol))
//				{	
//					AlternativeSymbol alterSym=curNode as AlternativeSymbol;
//					
//
//				}
//			}
		}

		private void barItemDispAlterDesc_Click(object sender, System.EventArgs e)
		{
		
		}

		private void diagram_MouseDown(object sender, System.Windows.Forms.MouseEventArgs e)
		{
			
		}

		private void barItemDispDesc_Click(object sender, System.EventArgs e)
		{
			foreach (INode curNode in this.diagram.Model.Nodes)
			{
				if (curNode.GetType() == typeof(clsConditionSymbol))
				{	
					clsConditionSymbol condSym=curNode as clsConditionSymbol;
					condSym.TextField=clsConditionSymbol.FieldsEnum.Description;
				}
			}
			diagram.Controller.UpdateView();
		}

		private void barItemDispCond_Click(object sender, System.EventArgs e)
		{
			foreach (INode curNode in this.diagram.Model.Nodes)
			{
				if (curNode.GetType() == typeof(clsConditionSymbol))
				{	
					clsConditionSymbol condSym=curNode as clsConditionSymbol;
					condSym.TextField=clsConditionSymbol.FieldsEnum.Expression;
				}
			}
			diagram.Controller.UpdateView();
		}

		private string mFileName;
		private void barItemOpen_Click(object sender, System.EventArgs e)
		{
			
			// Open diagram
			if (this.openDiagramDialog.ShowDialog(this) == DialogResult.OK)
			{
					barItemNew_Click(null,null);
					this.diagram.LoadBinary(this.openDiagramDialog.FileName);
					this.diagram.Refresh();
					this.mFileName = this.openDiagramDialog.FileName;
					RegisterCustomTools();
			}
		}

		private void barItemSave_Click(object sender, System.EventArgs e)
		{
			// Save diagram
			if (mFileName!=null & mFileName!="")
			{
				SaveAsFile(mFileName);
				RegisterCustomTools();
			}
			else
			{
				if (this.saveDiagramDialog.ShowDialog(this) == DialogResult.OK)
				{
					SaveAsFile(this.saveDiagramDialog.FileName);
					RegisterCustomTools();
				}
			}
			
		}

		
		private void SaveAsFile(string fileName)
		{
			FileStream oStream = null;
			
			try
			{
				oStream = new FileStream(fileName, FileMode.Create);
			}
			catch (Exception ex)
			{
				oStream = null;  // just to be sure
				MessageBox.Show("Error opening " + fileName + " - " + ex.Message);
			}

			if (oStream != null)
			{
				try
				{
					this.diagram.SaveBinary(oStream);
					mFileName = fileName;
				}
				catch (Exception ex)
				{
					MessageBox.Show("Serialization error - " + ex.Message);
				}
				finally
				{
					oStream.Close();
				}
			}
			this.diagram.Refresh();
			this.diagram.Controller.UpdateView();
		}


		private void barItemSaveAs_Click(object sender, System.EventArgs e)
		{
			// Save diagram
			if (mFileName!=null & mFileName!="")
			{
				this.saveDiagramDialog.FileName = mFileName;
			}
			if (this.saveDiagramDialog.ShowDialog(this) == DialogResult.OK)
			{
				SaveAsFile(this.saveDiagramDialog.FileName);
				RegisterCustomTools();
			}
		}

		//LINK_YES_COLOR=Color.LimeGreen
		//LINK_NO_COLOR=Color.BurlyWood
		
		private void barItemEditLink_Click(object sender, System.EventArgs e)
		{
			frmLinkEdit dlg=new frmLinkEdit();
			if (dlg.ShowDialog(this) == DialogResult.OK)
			{
				string sYesNo = dlg.YesNo;
				if (curLink!=null)
				{
					Label lblYesNo=curLink.GetChildByName(YES_NO_LABEL_NAME) as Label;
					lblYesNo.Text=sYesNo;
					if(sYesNo==YES_VALUE)
					{
						lblYesNo.Text=YES_VALUE; 
						lblYesNo.FillStyle.Color=System.Drawing.Color.LimeGreen;
						curLink.LineStyle.LineColor=Color.LimeGreen;
						curLink.FillStyle.Color=Color.LimeGreen;
					}
					else
					{
						lblYesNo.Text=NO_VALUE;
						lblYesNo.FillStyle.Color=System.Drawing.Color.BurlyWood;
						curLink.LineStyle.LineColor=Color.BurlyWood;
						curLink.FillStyle.Color=Color.BurlyWood;
					}

					//check Another link value Yes/No
					clsConditionSymbol condSym=curLink.FromNode as clsConditionSymbol;
										
					if (condSym.EdgesLeaving.Count==2)
					{
						Link linkAnother=null;
						
						for (int i=0;i<this.diagram.Model.Nodes.Count;i++)
						{
							Link linkTemp=this.diagram.Model.GetChild(i) as Link;
							if (linkTemp!=null)
							{
								if (linkTemp.FromNode==condSym & linkTemp!=curLink)
								{
									linkAnother=linkTemp;
									break;
								}
							}
						}
						if (linkAnother!=null)
						{
							Label lblAnother=linkAnother.GetChildByName(YES_NO_LABEL_NAME) as Label;
							if ( sYesNo==YES_VALUE)
							{
								lblAnother.Text=NO_VALUE;
								lblAnother.FillStyle.Color=System.Drawing.Color.BurlyWood;
								linkAnother.LineStyle.LineColor=Color.BurlyWood;
								linkAnother.FillStyle.Color=Color.BurlyWood;
							}
							else
							{
								lblAnother.Text=YES_VALUE;  //default label
								lblAnother.FillStyle.Color=System.Drawing.Color.LimeGreen;
								linkAnother.LineStyle.LineColor=Color.LimeGreen;
								linkAnother.FillStyle.Color=Color.LimeGreen;
							}
						}
					}


					this.diagram.View.SelectionList.Clear();
					this.diagram.View.Update();
					this.diagram.Focus();

				}
			}
		}

		private void barItemDelete_Click(object sender, System.EventArgs e)
		{
			this.diagram.Controller.Delete();
		}

		private void barItemHideYesNo_Click(object sender, System.EventArgs e)
		{
			ShowLinkLabel(false);
		}

		private void barItemDisplayYesNo_Click(object sender, System.EventArgs e)
		{
			ShowLinkLabel(true);
			
		}

		private void ShowLinkLabel(bool IsShow)
		{
			foreach (INode curNode in this.diagram.Model.Nodes)
			{
				if (curNode.GetType() == typeof(Link))
				{	
					Link lnk=curNode as Link;
					Label lblYesNo=lnk.GetChildByName(YES_NO_LABEL_NAME) as Label;
					lblYesNo.Visible=IsShow;
				}
			}
			mDisplayYesNo=IsShow;
			this.diagram.Controller.UpdateView();
		}

		private void diagram_MouseEnter(object sender, System.EventArgs e)
		{
			//this.diagram.Controller.UpdateView();
		}

		private void diagram_MouseLeave(object sender, System.EventArgs e)
		{
			//this.diagram.Controller.UpdateView();
		}

		private void barItemRedo_Click(object sender, System.EventArgs e)
		{
			if (this.diagram.Controller.RedoCount>0)
				this.diagram.Controller.RedoCommand();
		}

		private void barItemUndo_Click(object sender, System.EventArgs e)
		{
			if (this.diagram.Controller.UndoCount>0)
				this.diagram.Controller.UndoCommand();
			
		}

		private void barItemPreview_Click(object sender, System.EventArgs e)
		{
			PrintPreview();
		}
		private void PrintPreview()
		{
			Syncfusion.Windows.Forms.Diagram.Controls.Diagram activeDiagram = this.diagram;

			if (activeDiagram != null)
			{
				System.Drawing.Printing.PrintDocument printDoc = activeDiagram.CreatePrintDocument();
				PrintPreviewDialog printPreviewDlg = new PrintPreviewDialog();
				printPreviewDlg.Document = printDoc;
				printPreviewDlg.Width=Screen.PrimaryScreen.WorkingArea.Width;
				printPreviewDlg.Height=Screen.PrimaryScreen.WorkingArea.Height;
				printPreviewDlg.Left=Screen.PrimaryScreen.WorkingArea.Left;
				printPreviewDlg.Top=Screen.PrimaryScreen.WorkingArea.Top;
				printPreviewDlg.ShowDialog(this);
			}
		}

		private void barItemPrint_Click(object sender, System.EventArgs e)
		{
			Print();
		}
		private void Print()
		{
			Syncfusion.Windows.Forms.Diagram.Controls.Diagram activeDiagram = this.diagram;

			if (activeDiagram != null)
			{
				System.Drawing.Printing.PrintDocument printDoc = activeDiagram.CreatePrintDocument();
				PrintDialog printDlg = new PrintDialog();
				printDlg.Document = printDoc;
				if (printDlg.ShowDialog(this) == DialogResult.OK)
				{
					printDoc.Print();
				}
			}
		}

		private void barItemPan_Click(object sender, System.EventArgs e)
		{
			toolActivate("PanTool");
//			float xScale=this.diagram.Width/this.diagram.Model.Width;
//			float yScale=this.diagram.Height/this.diagram.Model.Height;
//			this.diagram.Model.Width=this.diagram.Width;
//			this.diagram.Model.Height=this.diagram.Height;
//			this.diagram.Model.Scale(xScale,yScale);
			
		}

		private void toolActivate(string toolName)
		{
			
				Tool tool = this.diagram.Controller.GetTool(toolName);
				if (tool != null)
				{
					if (tool.Active)
					{
						this.diagram.Controller.DeactivateTool(tool);
					}
					else
					{
						this.diagram.Controller.ActivateTool(tool);
					}
				}
		}

		private void barItemZoomTool_Click(object sender, System.EventArgs e)
		{
			toolActivate("ZoomTool");
		}

		private enum ActiveToolBarItems{Condition2Conditions=1,Condition2Alternatives,Other};
		private ActiveToolBarItems pActiveToolBarItem=ActiveToolBarItems.Other;
		private clsConditionSymbol CondSymAdded;
		private void barItemCond_Cond_Click(object sender, System.EventArgs e)
		{
			// 1 cond - 2 conds
			
			CondSymAdded= new clsConditionSymbol();
			this.insSymbolTool.Symbol = CondSymAdded;
			this.diagram.Controller.ActivateTool(this.insSymbolTool);
			pActiveToolBarItem=ActiveToolBarItems.Condition2Conditions;

			
		}

		private void barItemCond_Result_Click(object sender, System.EventArgs e)
		{
		
			CondSymAdded= new clsConditionSymbol();
			this.insSymbolTool.Symbol = CondSymAdded;
			this.diagram.Controller.ActivateTool(this.insSymbolTool);
			pActiveToolBarItem=ActiveToolBarItems.Condition2Alternatives;
		
			
		}


		
		private void diagram_Controller_ToolDeactivate(object sender, Syncfusion.Windows.Forms.Diagram.Controller.ToolEventArgs evtArgs)
		{

			if (pActiveToolBarItem==ActiveToolBarItems.Condition2Alternatives)
			{
				int iLevel=1;
				float curLeft = (float) (CondSymAdded.X-1*CondSymAdded.Width);//this.Model.Bounds.Left;
				float curRight = (float)(CondSymAdded.X+2*CondSymAdded.Width);//this.Model.Width;
		
				CreateTree(CondSymAdded,1,iLevel,curLeft,curRight,LeafNodeTypes.AlternativeSymbol);
				
			}

			if (pActiveToolBarItem==ActiveToolBarItems.Condition2Conditions)
			{
				int iLevel=1;
				float curLeft = (float) (CondSymAdded.X-1*CondSymAdded.Width);//this.Model.Bounds.Left;
				float curRight = (float)(CondSymAdded.X+2*CondSymAdded.Width);//this.Model.Width;
			
				CreateTree(CondSymAdded,1,iLevel,curLeft,curRight,LeafNodeTypes.ConditionSymbol);
				

			}
			pActiveToolBarItem=ActiveToolBarItems.Other;
		}

		private void diagram_Resize(object sender, System.EventArgs e)
		{
			
			
		}

		private void MainForm_Resize(object sender, System.EventArgs e)
		{
			
		}

		private void barItemPageSetup_Click(object sender, System.EventArgs e)
		{
			PageSetup();
		}

		private void PageSetup()
		{
			if (this.diagram.Model != null)
			{
				PageSetupDialog dlg = new PageSetupDialog();
				dlg.PageSettings = this.diagram.Model.PageSettings;
				if (dlg.ShowDialog(this) == DialogResult.OK)
				{
					this.diagram.Model.PageSettings = dlg.PageSettings;
				}
			}
		}

		private void barItemNew_Click(object sender, System.EventArgs e)
		{
			this.diagram.Model.Clear();
			this.diagram.Controller.ClearHistory();
			this.diagram.View.SelectionList.Clear();
			this.diagram.View.Update();
			this.diagram.Controller.UpdateAllViews();
			SetModelOrinialSize();


		}

		private void barItemAddPage_Click(object sender, System.EventArgs e)
		{
			ChangePage(1);
		}

		private void barItemDeletePage_Click(object sender, System.EventArgs e)
		{
			ChangePage(-1);
		}

		private void ChangePage(int PageNum)
		{
			
			if ((this.diagram.Model.Width+this.diagram.PageSettings.PaperSize.Width*PageNum)>=this.diagram.PageSettings.PaperSize.Width) 
				this.diagram.Model.Width=this.diagram.Model.Width+this.diagram.PageSettings.PaperSize.Width*PageNum;

		}


	}
}
